<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:dm="http://www.pnp-software.com/XFeature/displayModel">
	<xsl:output method="xml" version="1.0" encoding="UTF-8" indent="yes"/>

  <!-- ================================================================================== -->
  <!-- This file generates verifier of display meta-model instance. It checks whether     -->
  <!-- there are all nodes present and in case there is something missing it prints out   -->
  <!-- the error message. This stylesheet is based on DispalyMetamodel.dmm  -->
  <!-- ================================================================================== -->
  <!-- To run it (say, on Windows), create two-lines bath file containing e.g.:           -->
  <!-- c:\Programs\saxon\saxon SomeFeatureMetamodel.fmm DisplayModelCompiler.xsl > DisplayModelVerifier.xsl  -->
  <!-- c:\Programs\saxon\saxon SomeDisplayModel.xml DisplayModelVerifier.xsl                    -->
  <!-- ================================================================================== -->
  <!-- Copyright ETH Zurich, Switzerland, 2004                                            -->
  <!-- ================================================================================== -->
  
  <xsl:template match="/">
    <xsl:text disable-output-escaping="yes">
&lt;xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"&gt;
  &lt;!-- Copyright ETH Zurich, Switzerland, 2004 --&gt;

  &lt;xsl:output method="text" version="1.0" encoding="UTF-8" indent="yes"/&gt; 	
    &lt;xsl:template match="/"&gt;
    </xsl:text>
   		<xsl:apply-templates select="(//xs:element[xs:complexType[@dm:displayType='node' or @dm:displayType='propertySet' or @dm:displayType='property']])"/>
    <xsl:text disable-output-escaping="yes">    
  &lt;/xsl:template&gt;
&lt;/xsl:stylesheet&gt;

    </xsl:text>
  </xsl:template>

  <xsl:template match="//xs:element[xs:complexType]">
      <xsl:variable name="format">        <xsl:choose>            <xsl:when test="xs:complexType/@dm:displayType='node'">NodeDisplayFormat</xsl:when>            <xsl:when test="xs:complexType/@dm:displayType='propertySet'">PropertySetDisplayFormat</xsl:when>            <xsl:when test="xs:complexType/@dm:displayType='property'">PropertyDisplayFormat</xsl:when>            <xsl:otherwise><xsl:message terminate="yes">DisplayModelCompiler.xsl (in template //xs:element[xs:complexType]): Unexpected (fixed) type -- known as nodeType (now "value") attribute in DisplayMetamodel.dmm (1)</xsl:message></xsl:otherwise>        </xsl:choose>    </xsl:variable>    <xsl:variable name="nodeOrType">        <xsl:choose>            <xsl:when test="xs:complexType/@dm:displayType='node'">value</xsl:when>            <xsl:when test="xs:complexType/@dm:displayType='propertySet'">value</xsl:when>            <xsl:when test="xs:complexType/@dm:displayType='property'">value</xsl:when>            <xsl:otherwise><xsl:message terminate="yes">DisplayModelCompiler.xsl (in template xs:element): Unexpected (fixed) type -- known as value (former nodeType) attribute in DisplayModel.dm (2)</xsl:message></xsl:otherwise>        </xsl:choose>    </xsl:variable>        <xsl:variable name="formatAndNodeOrType" select="concat($format,'/@',$nodeOrType)"/>
    <xsl:text disable-output-escaping="yes">
    <!-- 
    Positive message (i.e. 'check passed successfuly')  
    removed to have zero size file if everything is OK
    
    &amp;lt;xsl:choose&amp;gt;        &lt;!==NodeDisplayModel will be repalce accoridnig to nodeType==&gt;
        &amp;lt;xsl:when test=&quot;(//DisplayModel/&lt;/xsl:text&gt;&lt;xsl:value-of select=&quot;$formatAndNodeOrType&quot;/&gt;&lt;xsl:text&gt;=&apos;&lt;/xsl:text&gt;&lt;xsl:apply-templates select=&quot;@name&quot;/&gt;&apos;&lt;xsl:text disable-output-escaping=&quot;yes&quot;&gt;)&quot;&amp;gt;&lt;/xsl:text&gt;        ... check of &quot;&lt;xsl:apply-templates select=&quot;@name&quot;/&gt;&quot; element passed successfuly.&lt;xsl:text disable-output-escaping=&quot;yes&quot;&gt;        &amp;lt;/xsl:when&amp;gt;
        &amp;lt;xsl:otherwise&amp;gt;  &lt;!==//NodeDisplayFormat[@nodeType]==&gt;
            &amp;lt;xsl:message terminate=&quot;yes&quot;&amp;gt;ERROR: Node check &quot;&lt;/xsl:text&gt;&lt;xsl:apply-templates select=&quot;@name&quot;/&gt;&lt;xsl:text disable-output-escaping=&quot;yes&quot;&gt;&quot; failed! 
       Check the &lt;/xsl:text&gt;&lt;xsl:value-of select=&quot;$nodeOrType&quot;/&gt;&lt;xsl:text&gt; attribute of this element. 
       It should have value &lt;/xsl:text&gt;&lt;xsl:value-of select=&quot;$format&quot;/&gt;&lt;xsl:text disable-output-escaping=&quot;yes&quot;&gt;.&amp;lt;/xsl:message&amp;gt;
        &amp;lt;/xsl:otherwise&amp;gt;
    &amp;lt;/xsl:choose&amp;gt;
    -->
    &lt;xsl:choose&gt;        <!--NodeDisplayModel will be repalce accoridnig to nodeType-->
         &lt;xsl:when test="(//DisplayModel/</xsl:text><xsl:value-of select="$formatAndNodeOrType"/><xsl:text>='</xsl:text><xsl:apply-templates select="@name"/>'<xsl:text disable-output-escaping="yes">)"&gt;</xsl:text><xsl:text disable-output-escaping="yes">        &lt;/xsl:when&gt;
         &lt;xsl:otherwise&gt;  <!--//NodeDisplayFormat[@nodeType]-->
         &lt;xsl:message terminate="yes"&gt;ERROR: Node check "</xsl:text><xsl:apply-templates select="@name"/><xsl:text disable-output-escaping="yes">" failed! 
           Check the </xsl:text><xsl:value-of select="$nodeOrType"/><xsl:text> attribute of this element. 
             It should have value </xsl:text><xsl:value-of select="$format"/><xsl:text disable-output-escaping="yes">.&lt;/xsl:message&gt;
         &lt;/xsl:otherwise&gt;
    &lt;/xsl:choose&gt;
                 
    </xsl:text>
  </xsl:template>

</xsl:stylesheet>
